#include "io.hpp"
#include "itemperature_calculator.hpp"
#include <algorithm>
#include <cmath>
#include <iostream>
#include <memory>
#include <stdexcept>
#include <vector>

using namespace Solver;
using calculationType = ITemperatureCalculator::calculationType;

static std::string_view handleCommandLineArgs(int argc, char* argv[]);

/// Program is designed for calculating auto-generated by sin function
/// temperatures after some proceeded. Program can read input parameters from
/// file or use default
int main(int argc, char* argv[], char* /*env*/[])
{
    // Input should evoke with input file name parameter. By default function
    // will be calculated with default parameters defined if function
    // getDefaultInitialParameters. Output can be redirected on Linux to file
    // with: ./heatconduction 1>[file_name_cout] 2>[file_name_cerr_clog]
    auto filePath = handleCommandLineArgs(argc, argv);

    auto programInitialParam = getInitialParameters(filePath);

    const auto numberOfNodes =
        programInitialParam.solverInitialParameters.numberOfParticles + 1;

    const auto initialTemperatures{ generateNodesInitialTemperature(
        programInitialParam.maxInitialTemperature, numberOfNodes) };

    if (!printTemperatures(std::cout, initialTemperatures,
                           programInitialParam.solverInitialParameters,
                           programInitialParam.timeToPredict, "Initial"))
    {
        return EXIT_FAILURE;
    }

    auto resultTemperatures = initialTemperatures;

    std::unique_ptr<ITemperatureCalculator> temperatureCalculator;

    try
    {
        temperatureCalculator =
            ITemperatureCalculator::createCalculatorExplicitDifference(
                programInitialParam.solverInitialParameters);
    }
    catch (std::invalid_argument& ex)
    {
        std::cerr << "Unable to create calculator class. Some values out of "
                     "border. Description: "
                  << ex.what() << std::endl;
        return EXIT_FAILURE;
    }

    temperatureCalculator->setMarginForConvergentCondition(
        programInitialParam.convergentMargin);

    temperatureCalculator->updateTemperatureForTime(
        programInitialParam.timeToPredict, resultTemperatures);

    if (!printTemperatures(std::cout, resultTemperatures,
                           programInitialParam.solverInitialParameters,
                           programInitialParam.timeToPredict, "Result"))
    {
        return EXIT_FAILURE;
    }

    const auto isCsteamsOk = static_cast<bool>(std::cout) &&
                             static_cast<bool>(std::clog) &&
                             static_cast<bool>(std::cerr);

    return (isCsteamsOk) ? EXIT_SUCCESS : EXIT_FAILURE;
}

static std::string_view handleCommandLineArgs(int argc, char* argv[])
{
    if (argc < 2)
    {
        return {};
    }
    if (argc != 2)
    {
        std::cerr << "Warning program can handle only 0 or 1 argument. "
                     "Remaining arguments is omited."
                  << std::endl;
    }

    std::string_view argument = argv[1];

    return argument;
}
